# KnockoutJS APP Starter
> Build Single-Page apps with KnockoutJS

Rapidly prototype your next single-page application, with a `zero-build` out-of-the-box web-component solution. Need to go beyond the prototype stage, fret not, the tools are in-place to take you to production.

This is as simple as possible, but no simpler

*Designed for web componets in both legacy and modern browsers*

### Features

- `KnockoutJS` 3.4.x
    - `Web Components` for reuseable UI
- `Bootstrap` 3.x
- `JQuery` 1.11.x
- Based on `HTML5Boilerplate` 6.x
- `ESLint` for coding style
- `Jasmine` for testing
- `Gulp` for production builds
    - `Rollup` to only export the code your using

## Getting Started

## Why Zero-Build?

**SPEED!**

A production pipe-line should *NOT* be in your way while developing...

...however, `npm build` adds it when you need it

## How

## Project Structure

## Polyfills

Todays "Evergreens" browsers support 99% of `ES6`, providing a pethra of capabilities, such as `import`, `class`, `fetch`, and `promise`.  Depending on your desired browser support, you may find a polyfill to suit your needs, **HOWEVER** this build is designed to work with IE8+

...but such is beyond the scope of *this* starter package.

## TODO

- add a ko.subscrible() utility to manage communication between components
- add a simple router
- add gulp build process for production builds
- add Jasmine for testing
- evaluate
    - jquery migrate patch
    - html5 shim
